## Gravitationsgesetz nach Reilly
## Interaktives Skript fuer R
##
## (c) Detlev Reymann 2007
## detlev@reymann.eu
## Letzte Bearbeitung 10.06.2006

## Funktion ZahlInteraktivEinlesen
## Hilfsfunktion fuer die interaktive Eingabe
ZahlInteraktivEinlesen <- function()
{
  Eingabe <- NA;
  while (is.na(Eingabe)) {
     cat("Bitte Wert eingeben: ");
     (Eingabe <- as.numeric(readLines(stdin(), 1)));
  }
  return(Eingabe);
}
##
## Abfrage der noetigen Parameter
##
cat("\n");
cat("=============================================");
cat("\n");
cat("Berechnung der Umsatzanteile zweier Standorte\nnach dem Gravitationsgesetz von Reilly.\n");
cat("=============================================");
cat("\n");
cat("\n");
cat("Bitte geben Sie nachfolgend die Werte fuer die notwendigen Parameter ein.\n")
cat("\n");
cat("Angaben zur Attraktivitaet\n");
cat("---------------------------------------------");
cat("\n");
cat("Reilly operationalisiert die Standortattraktivitaet urspruenglich mit Hilfe\nder Einwohnerzahl spaeter auch durch die Einkaufsflaeche\n");
cat("\n");
cat("Attraktivitaetsfaktor fuer Standort 1:\n");
A1 <- ZahlInteraktivEinlesen();
cat("Attraktivitaetsfaktor fuer Standort 2:\n");
A2 <- ZahlInteraktivEinlesen();
cat("Der Gewichtungsfaktor der Attraktivitaet muss eigentlich empirisch ermittelt werden,\nReilly empfiehlt urspruenglich den Wert 1\n");
cat("Gewichtungsfaktor Beta1:\n");
Beta1 <- ZahlInteraktivEinlesen();
cat("\n");
cat("Angaben zu den Distanzen\n");
cat("---------------------------------------------");
cat("\n");
cat("Distanz zu Standort 1:\n");
d1 <- ZahlInteraktivEinlesen();
cat("Distanz zu Standort 2:\n");
d2 <- ZahlInteraktivEinlesen();
cat("Der Gewichtungsfaktor der Distanzen muss eigentlich empirisch ermittelt werden,\nReilly empfiehlt urspruenglich den Wert 2\n");
cat("Gewichtungsfaktor Beta2:\n");
Beta2 <- ZahlInteraktivEinlesen();
##
## Hier die eigentliche Berechnung
##
Umsatzrelation <- ((A1/A2)^Beta1)*((d1/d2)^Beta2);
Umsatz1 <- Umsatzrelation/(1+Umsatzrelation)*100;
Umsatz2 <- (100-Umsatz1);
##
## Ausgabe des Ergebnisses
##
cat("\n");
cat("Berechnung des Umsatzes nach Reillys Gravitationsgesetz,");
cat("\n");
cat("es wurden folgende Ausgangswerte verwendet:");
cat("\n");
cat("Attraktivitaetsfaktor Standort 1: ");print(A1);
cat("Attraktivitaetsfaktor Standort 2: ");print(A2);
cat("Gewichtungsfaktor der Attraktivitaeten - Beta 1: ");print(Beta1);
cat("Distanz zu Standort 1: ");print(d1);
cat("Distanz zu Standort 2: ");print(d2);
cat("Gewichtungsfaktor der Distanzen - Beta 2: ");print(Beta2);
cat("\n");
cat("Die Umsatzrelation zwischen Standort 1 und Standort 2 betraegt: \n");
print(Umsatzrelation);
cat("Der Umsatz des untersuchten Ortes teilt sich folgendermassen auf:\n");
cat("Standort 1 erhaelt in Prozent des Umsatzes: ");print(Umsatz1);
cat("Standort 2 erhaelt in Prozent des Umsatzes: ");print(Umsatz2);
